# PUT Requests

(**BETA**) Now it is possible to scrape forms or API endpoints directly. You can do this by sending a PUT request to Shifter's Web Scraping API with your **api\_key** and **URL** parameter.

In the right-side box, you will find an example request used to scrape the URL <https://httpbin.org/put>

### PUT Requests examples

> **`PUT https://scrape.shifter.io/v1?api_key=api_key&url=https://httpbin.org/put`**

**⇡ Input**

{% tabs %}
{% tab title="cURL" %}

```url
curl --request PUT --url "https://scrape.shifter.io/v1?api_key=api_key&url=https%3A%2F%2Fhttpbin.org%2Fput" --data "{
  "foo": "bar"
}"
```

{% endtab %}

{% tab title="NodeJS" %}

```javascript
const http = require("https");

const options = {
  "method": "PUT",
  "hostname": "scrape.shifter.io",
  "port": null,
  "path": "/v1?api_key=api_key&url=https%3A%2F%2Fhttpbin.org%2Fput",
  "headers": {}
};

const req = http.request(options, function (res) {
  const chunks = [];

  res.on("data", function (chunk) {
    chunks.push(chunk);
  });

  res.on("end", function () {
    const body = Buffer.concat(chunks);
    console.log(body.toString());
  });
});

req.write("{\n  \"foo\": \"bar\"\n}");
req.end();
```

{% endtab %}

{% tab title="Python" %}

```python
import http.client

conn = http.client.HTTPSConnection("scrape.shifter.io")

payload = "{\n  \"foo\": \"bar\"\n}"

conn.request("PUT", "/v1?api_key=api_key&url=https%3A%2F%2Fhttpbin.org%2Fput", payload)

res = conn.getresponse()
data = res.read()

print(data.decode("utf-8"))
```

{% endtab %}

{% tab title="PHP" %}

```php


```

{% endtab %}
{% endtabs %}

**⇣ Output**

```
{
    "args": {},
    "data": "{\"foo\":\"bar\"}",
    "files": {},
    "form": {},
    "headers": {
        "Accept": "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8",
        "Accept-Encoding": "gzip, deflate, br",
        "Content-Length": "13",
        "Content-Type": "application/json",
        "Host": "httpbin.org",
        "Upgrade-Insecure-Requests": "1",
        "User-Agent": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.69 Safari/537.36",
        "X-Amzn-Trace-Id": "Root=1-6267eb77-3bbe26043611b895363f145a"
    },
    "json": {
        "foo": "bar"
    },
    "origin": "185.162.168.36",
    "url": "https://httpbin.org/put"
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.shifter.io/scraping-api/web-scraping-api/put-requests.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
